/*
  cadaverserver
  Copyright (C) 1999  Erik Thiele

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "spielfeld.hpp"

feld::feld ()
{
  for (int i=0;i<floatvalue_count();i++) floatvalue[i]=0;
};

const char *const feld::floatvalue_textdescription (const floatvalue_type number)
{
  switch (number) {
  case WATER: return "water"; break;
  case GRAIN: return "grain"; break;
  case GRASS: return "grass"; break;
  case CARCASS: return "carcass"; break;
  case HAY: return "hay"; break;
  case MEAT: return "meat"; break;
  case BREAD: return "bread"; break;
  case FOREST: return "forest"; break;
  default: return "unknown"; break;
  };
};

void feld::dump (char *buf) const
{
  if (floatvalue[WATER]==-1.0) {
    buf[0]='x';
    buf[1]=0;
  }else{
    int i;
    char c;
    for (i=0; i<floatvalue_count(); i++) {
      c = char(floatvalue[i]*10.0) + '0';
      if (c > '9') c = '9';
      if (c < '0') c = '0';
      buf[i] = c;
    };
    buf[i] = 0;
  };
};

void feld::load (const char *buf)
{
  int i;
  if (buf[0]=='x') {
    floatvalue[WATER]=-1.0;
    for (i=1; i<floatvalue_count(); i++)
      floatvalue[i]=0;
  }else{
    for (i=0; i<floatvalue_count(); i++)
      floatvalue[i]=(buf[i]-'0')/10.0+0.05;
  };
};
