/*

  zeit - some time management routines
  Copyright (C) 2000  Erik Thiele

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include "yyyzeit.hpp"

#include <unistd.h>
#include <sys/time.h>

using namespace yyyzeit;

void zeit::setseconds_asdouble (const double seconds)
{
  microsec=reptype(seconds*double(1000000));
};

const double zeit::getseconds_asdouble () const
{
  return double(microsec)/double(1000000);
};

void zeit::convert_to_timeval (struct timeval & tv) const
{
  // FIXME this conversion can fail. there must be an error thrown then.
  reptype x(microsec);
  if (isnegative()) x=-x;
  tv.tv_usec=microsec % 1000000;
  tv.tv_sec=microsec / 1000000;
  if (isnegative()) tv.tv_sec=-tv.tv_sec;
};

const zeit yyyzeit::getcurrenttime ()
{
  struct timeval tv;
  gettimeofday (&tv, 0);
  zeit t;
  t.setmicroseconds(zeit::reptype(tv.tv_usec)+zeit::reptype(tv.tv_sec)*1000000);
  return t;
};
